if(!window.ScoreViewerIIDX19){
	ScoreViewerIIDX19_setup();
}
with(ScoreViewerIIDX19){

openMusicWindow = function (mid){
	var view_rival = function(i){
		return sv19_Branch.getBoolPref("view_rival" + i);
	}
	var view_flag_sp = 0;
	var view_flag_dp = 0;
	if(view_rival(0)){
		view_flag_sp += 1;
	}
	if(view_rival(1)){
		view_flag_sp += 1;
	}
	if(view_rival(2)){
		view_flag_sp += 1;
	}
	if(view_rival(3)){
		view_flag_dp += 1;
	}
	if(view_rival(4)){
		view_flag_dp += 1;
	}
	if(view_rival(5)){
		view_flag_dp += 1;
	}

	var rival_score = new Array(6);
	rival_score[0] = new Array();
	rival_score[1] = new Array();
	rival_score[2] = new Array();
	rival_score[3] = new Array();
	rival_score[4] = new Array();
	rival_score[5] = new Array();

	//メインユーザー検知
	var user_num = -1;
	for(var i=0; i<user_data.length; i++){
		if((user_data[i].category == 0)&&(user_data[i].version == 19)){
			if(user_num == -1){
				user_num = i;
			}else{
				if(user_data[i].time.main > user_data[user_num].time.main){
					user_num = i;
				}
			}
		}
	}

	function openMusicWindowOnload(){
		if((view_flag_sp==0)&&(view_flag_dp==0)){
			alert("どの難易度も表示する設定になっていません。");
			return;
		}

		musicTab = gBrowser.getBrowserForTab(gBrowser.selectedTab = gBrowser.addTab("chrome://ScoreViewerForIIDX19/content/music.html"));
		musicTab.addEventListener("load", function(){
			musicTab.removeEventListener("load", arguments.callee, true);
			var htmlText = music_list['music_list'][mid]['name'] + "<BR>\n";
			htmlText += "<table class=\"music\">\n";
			if(view_flag_sp!=0){
				htmlText += "<tr class=\"playcount\">\n";
				htmlText += "	<td colspan=\"" + view_flag_sp + "\">\n";
				htmlText += "		<table width=\"100%\">\n";
				htmlText += "		<tr>\n";
				htmlText += "			<td align=\"left\">SINGLE</td>\n";
				if((user_num != -1)&&(mid in user_data[user_num].playcount)){
					htmlText += "			<td align=\"right\">選曲数:" + user_data[user_num].playcount[mid][0] + "回</td>\n";
				}
				htmlText += "		</tr>\n";
				htmlText += "		</table>\n";
				htmlText += "	</td>\n";
				htmlText += "</tr>\n";
				htmlText += "<tr class=\"level\">\n";
				if(view_rival(0)){
					htmlText += "	<td class=\"normal\">\n";
					htmlText += "		<table width=\"100%\">\n";
					htmlText += "		<tr>\n";
					htmlText += "		<td align=\"left\">NORMAL</td>\n";
					if(music_list['music_list'][mid]['diff'][0] != 0){
						htmlText += "		<td align=\"right\">☆" + music_list['music_list'][mid]['diff'][0] + "</td>\n";
					}
					htmlText += "		</tr>\n";
					htmlText += "		</table>\n";
					htmlText += "	</td>\n";
				}
				if(view_rival(1)){
					htmlText += "	<td class=\"hyper\">\n";
					htmlText += "		<table width=\"100%\" border=\"0\">\n";
					htmlText += "		<tr>\n";
					htmlText += "		<td align=\"left\">HYPER</td>\n";
					if(music_list['music_list'][mid]['diff'][1] != 0){
						htmlText += "		<td align=\"right\">☆" + music_list['music_list'][mid]['diff'][1] + "</td>\n";
					}
					htmlText += "		</tr>\n";
					htmlText += "		</table>\n";
					htmlText += "	</td>\n";
				}
				if(view_rival(2)){
					htmlText += "	<td class=\"another\">\n";
					htmlText += "		<table width=\"100%\" border=\"0\">\n";
					htmlText += "		<tr>\n";
					htmlText += "		<td align=\"left\">ANOTHER</td>\n";
					if(music_list['music_list'][mid]['diff'][2] != 0){
						htmlText += "		<td align=\"right\">☆" + music_list['music_list'][mid]['diff'][2] + "</td>\n";
					}
					htmlText += "		</tr>\n";
					htmlText += "		</table>\n";
					htmlText += "	</td>\n";
				}
				htmlText += "</tr>\n";
				htmlText += "<tr align=\"center\">\n";
				if(view_rival(0)){
					htmlText += "	<td>" + viewRivalWinLose(mid,0) + "</td>\n";
				}
				if(view_rival(1)){
					htmlText += "	<td>" + viewRivalWinLose(mid,1) + "</td>\n";
				}
				if(view_rival(2)){
					htmlText += "	<td>" + viewRivalWinLose(mid,2) + "</td>\n";
				}
				htmlText += "</tr>\n";
			}
			if(view_flag_dp!=0){
				htmlText += "<tr class=\"playcount\">\n";
				htmlText += "	<td colspan=\"" + view_flag_dp + "\">\n";
				htmlText += "		<table width=\"100%\">\n";
				htmlText += "		<tr>\n";
				htmlText += "			<td align=\"left\">DOUBLE</td>\n";
				if((user_num != -1)&&(mid in user_data[user_num].playcount)){
					htmlText += "			<td align=\"right\">選曲数:" + user_data[user_num].playcount[mid][1] + "回</td>\n";
				}
				htmlText += "		</tr>\n";
				htmlText += "		</table>\n";
				htmlText += "	</td>\n";
				htmlText += "</tr>\n";
				htmlText += "<tr class=\"level\">\n";
				if(view_rival(3)){
					htmlText += "	<td class=\"normal\">\n";
					htmlText += "		<table width=\"100%\" border=\"0\">\n";
					htmlText += "		<tr>\n";
					htmlText += "		<td align=\"left\">NORMAL</td>\n";
					if(music_list['music_list'][mid]['diff'][3] != 0){
						htmlText += "		<td align=\"right\">☆" + music_list['music_list'][mid]['diff'][3] + "</td>\n";
					}
					htmlText += "		</tr>\n";
					htmlText += "		</table>\n";
					htmlText += "	</td>\n";
				}
				if(view_rival(4)){
					htmlText += "	<td class=\"hyper\">\n";
					htmlText += "		<table width=\"100%\" border=\"0\">\n";
					htmlText += "		<tr>\n";
					htmlText += "		<td align=\"left\">HYPER</td>\n";
					if(music_list['music_list'][mid]['diff'][4] != 0){
						htmlText += "		<td align=\"right\">☆" + music_list['music_list'][mid]['diff'][4] + "</td>\n";
					}
					htmlText += "		</tr>\n";
					htmlText += "		</table>\n";
					htmlText += "	</td>\n";
				}
				if(view_rival(5)){
					htmlText += "	<td class=\"another\">\n";
					htmlText += "		<table width=\"100%\" border=\"0\">\n";
					htmlText += "		<tr>\n";
					htmlText += "		<td align=\"left\">ANOTHER</td>\n";
					if(music_list['music_list'][mid]['diff'][5] != 0){
						htmlText += "		<td align=\"right\">☆" + music_list['music_list'][mid]['diff'][5] + "</td>\n";
					}
					htmlText += "		</tr>\n";
					htmlText += "		</table>\n";
					htmlText += "	</td>\n";
				}
				htmlText += "</tr>\n";
				htmlText += "<tr align=\"center\">\n";
				if(view_rival(3)){
					htmlText += "	<td>" + viewRivalWinLose(mid,3) + "</td>\n";
				}
				if(view_rival(4)){
					htmlText += "	<td>" + viewRivalWinLose(mid,4) + "</td>\n";
				}
				if(view_rival(5)){
					htmlText += "	<td>" + viewRivalWinLose(mid,5) + "</td>\n";
				}
				htmlText += "</tr>\n";
			}
			htmlText += "</table>\n";
			htmlText += "<input type=\"button\" value=\"close\" onclick=\"javascript:self.close();\">\n";

			musicTab.contentDocument.title = music_list['music_list'][mid]['name'] + " - Score Viewer for beatmania IIDX 19 Lincle";
			musicTab.contentDocument.body.innerHTML = htmlText;
		}, true);

		return;
	}

	function viewRivalWinLose(mid, diff){
		for(var i=0; i<rival_score[diff].length; i++){
			if(rival_score[diff][i].score > 0){
				break;
			}
		}
		if((music_list["music_list"][mid]["diff"][diff]==0)&&(i==rival_score[diff].length)){
			return "NO DATA";
		}else{
			var img_url = "http://p.eagate.573.jp/game/2dx/19/p/";

			var tmp = 0;
			var class_array = new Array("odd","even");
			var class_txt = "";
			var txt = "";
			var rank = 0;
			txt += "<table class=\"rank\">\n";
			for(var i=0; i<rival_score[diff].length; i++){
				if(rival_score[diff][i].cat==0){
					if(rival_score[diff][i].mainuser){
						class_txt = "my";
					}else{
						class_txt = "my2";
					}
				}else if(rival_score[diff][i].cat==2){
					class_txt = "top";
				}else{
					class_txt = class_array[tmp];
				}
				txt += "<tr class=\"" + class_txt + "\">\n";
				if(i==0){
					rank = 1;
				}else if(rival_score[diff][i].score!=rival_score[diff][i-1].score){
					rank = i + 1;
				}
				txt += "	<td class=\"col_rank\">" + rank + "</td>\n";
				if(rival_score[diff][i].cat == 2){
					txt += "	<td class=\"col_name\">" + rival_score[diff][i].topname + "</td>\n";
				}else{
					txt += "	<td class=\"col_name\">" + rival_score[diff][i].name + "</td>\n";
				}
				if(rival_score[diff][i].cat == 2){
					txt += "	<td class=\"col_clear\">" + rival_score[diff][i].name + "</td>\n";
				}else{
					txt += "	<td class=\"col_clear\"><img src='" + img_url + "images/score_icon/clflg" + rival_score[diff][i].clear + ".gif' alt='" + LampIntToStr(rival_score[diff][i].clear) + "' /></td>\n";
				}
				if(rival_score[diff][i].djlv == -1){
					txt += "	<td class=\"col_djlv\">&nbsp;</td>\n";
				}else{
					txt += "	<td class=\"col_djlv\"><img src='" + img_url + "images/score_icon/" + RankIntToStr(rival_score[diff][i].djlv) + ".gif' alt='" + RankIntToStr(rival_score[diff][i].djlv) + "' /></td>\n";
				}
				if(rival_score[diff][i].score == -1){
					txt += "	<td class=\"col_score\">-</td>\n";
				}else{
					txt += "	<td class=\"col_score\">" + rival_score[diff][i].score + "</td>\n";
				}
				if(sv19_Branch.getBoolPref("view_miss")){
					if(rival_score[diff][i].miss == -1){
						txt += "	<td class=\"col_miss\">-</td>\n";
					}else{
						txt += "	<td class=\"col_miss\">" + rival_score[diff][i].miss + "</td>\n";
					}
				}
				if((sv19_Branch.getBoolPref("view_date"))){
						txt += "	<td class=\"col_date\">" + rival_score[diff][i].time + "</td>\n";
				}
				txt += "</tr>\n";
				if(tmp == 0){
					tmp = 1;
				}else{
					tmp = 0;
				}
			}
			txt += "</table>\n";
			return txt;
		}
	}

	function readMyScore(){
		for(var i=0;i<6;i++){
			for(var j=0;j<user_data.length;j++){
				var data = new Object();
				data.cat = user_data[j].category;
				data.name = user_data[j].name;
				data.score = -1;
				data.clear = -1;
				data.djlv = -1;
				data.miss = -1;
				data.topname = "NO DATA";
				data.time = "NO DATA";
				
				try{
					data.score = Number(user_data[j].score[mid][i]);
					if(isNaN(data.score)){
						data.score = -1;
					}
				}catch(e){}
				try{
					data.clear = user_data[j].clear[mid][i];
				}catch(e){}
				try{
					data.djlv = user_data[j].djlv[mid][i];
				}catch(e){}
				try{
					data.miss = Number(user_data[j].miss[mid][i]);
					if(isNaN(data.miss)){
						data.miss = -1;
					}
				}catch(e){}
				try{
					data.topname = user_data[j].topname[mid][i];
				}catch(e){}
				try{
					data.time = user_data[j].time[mid][i];
				}catch(e){}
				
				if(j == user_num){
					data.mainuser = true;
				}else{
					data.mainuser = false;
				}
				
				rival_score[i].push(data);
/*
				if(user_data[j].category==0){
					rival_score[i].push(new Array(cat, name, clear, djlv, score, miss);
				}else if(user_data[j].category==1){
					rival_score[i].push(new Array(cat, name, clear, djlv, score, miss);
				}else if(user_data[j].category==2){
					rival_score[i].push(new Array(cat, topname, name, djlv, score, "-"));
				}
*/
			}
		}
		return;
	}

	function sortRivalScore(){
		var flag = true;
		for(var i=0; i<6; i++){
			for(var j=0; j<rival_score[i].length; j++){
				for(var k=rival_score[i].length-1; k>j; k--){
					if(rival_score[i][k].score > rival_score[i][k-1].score){
						flag = true;
					}else if(rival_score[i][k].score == rival_score[i][k-1].score){
						var tmp1 = Number(rival_score[i][k].clear);
						if(isNaN(tmp1)) tmp1 = -1;
						var tmp2 = Number(rival_score[i][k-1].clear);
						if(isNaN(tmp2)) tmp2 = -1;
						if(tmp1 > tmp2){
							flag = true;
						}else if(tmp1 == tmp2){
							if(rival_score[i][k-1].miss == -1){
								flag = false;
							}else if(rival_score[i][k].miss == -1){
								flag = true;
							}else if(rival_score[i][k].miss < rival_score[i][k-1].miss){
								flag = true;
							}else{
								flag = false;
							}
						}else{
							flag = false;
						}
					}else{
						flag = false;
					}
					if(flag){
						var tmp = rival_score[i][k-1];
						rival_score[i][k-1] = rival_score[i][k];
						rival_score[i][k] = tmp;
					}
				}
			}
		}
		return;
	}

	readMyScore();
	sortRivalScore();
	openMusicWindowOnload();
	return;

}

}
