function ScoreViewerIIDX19_setup(){
	ScoreViewerIIDX19 = {
		URL1: "http://p.eagate.573.jp/game/2dx/19/p/",
		URL2: "http://nobuyukim.cs.land.to/iidx_score/import_ac.php",
		URL3: "http://localhost/iidx_score/import_ac.php",
		URL_official_login: 'p.eagate.573.jp/gate/p/login.html',
		URL_rival: "http://p.eagate.573.jp/game/2dx/19/p/djdata/data_another.html",
		URL_info: "http://nobuyukim.cs.land.to/scoreviewer/IIDX19/info_scoreviewer19.txt",
		URL_vdata: "http://nobuyukim.cs.land.to/scoreviewer/IIDX19/version_scoreviewer19.txt",
		URL_vinfo: "http://nobuyukim.cs.land.to/scoreviewer/IIDX19/vinfo_scoreviewer19.txt",
		URL_iidxpr: "saryou.jp/iidxpr/LINC/dj/editMusic/",

		sv19_prefs: Components.classes["@mozilla.org/preferences-service;1"].getService(Components.interfaces.nsIPrefService),
//		sv19_Branch: sv19_prefs.getBranch("extensions.ScoreViewerForIIDX19."),
		sv19_Branch: Components.classes["@mozilla.org/preferences-service;1"].getService(Components.interfaces.nsIPrefService).getBranch("extensions.ScoreViewerForIIDX19."),
		addon_Branch: Components.classes["@mozilla.org/preferences-service;1"].getService(Components.interfaces.nsIPrefService).getBranch("extensions.nob_m-konami."),

		scoreviewer19_version: "",
		data_version: "",
		data_version18: "",

		user_data: "",
		diff_name: "",
		diff_color: "",
		num_rival_view: "",
		music_list: "",
		music_id: "",
		view_list: "",
		rival_data: "",
		rival_top_data: "",
		unofficial_diff: "",

		timerID: "",
		mainTab: "",
		musicTab: "",
		djpTab: "",
		rivalTab: "",
		exTab: "",

		timeout: 30000,

		userLoadData: "",
		readStatus: new Object(),
		musiclist_special: new Object(),
		readTask: "",

		clone: function(obj){
			return eval(uneval(obj));
		},

		//version.js
		savedataCheck: "",
		savedataConvert: "",

		//ScoreViewerIIDX19.js
		userDataDefault: "",
		sortMusic: "",
		scoreViewerSetup: "",
		readInfo: "",
		readVersionInfo: "",

		//maintab.js
		setData: "",
		removeData: "",
		getData: "",
		strFullToHalf: "",
		buttonDisable: "",
		iobuttonDisable: "",
		categoryEnable: "",
		categoryDisable: "",
		buttonEnable: "",
		ioButtonEnable: "",
		beginnerLevelExchange: "",
		sortViewList: "",
		writeCategory: "",
		makeFolder: "",
		removeFolderEvent: "",
		addFolderEvent: "",
		changeFolder: "",
		correctMusic: "",
		makeViewList: "",
		writeMultiScore: "",
		writeSingleScore: "",
		searchDani: "",
		searchStepup: "",
		makePageNum: "",
		removePageEvent: "",
		makePageButton: "",
		writeScore: "",
		writeText: "",
		removeMusicEvent: "",
		addMusicEvent: "",
		keepLogin: "",
		viewDjPoint: "",
		editRival: "",
		readImg: "",
		readLampInt: "",
		readRankStr: "",
		readRankInt: "",
		RankStrToInt: "",
		RankIntToStr: "",
		LampIntToStr: "",
		readStr: "",
		readPlayCount: "",
		readScore: "",
		readPgreat: "",
		readGreat: "",
		readMiss: "",
		trim: "",
		readList: "",
		matchWordLine: "",
		iidx_id_Check: "",
		readDjName: "",
		pushTask: "",
		checkTask: "",
		prepareData: "",
		musicRename: "",
		on_loaded: "",
		on_loaded_rival: "",
		GetScore_loop: "",
		GetScore_loop_Top: "",
		readFinalAlert: "",
		readCompleteAlert: "",
		setupWindow: "",
		buttonDisableImport: "",
		viewRivalList: "",
		reloadAllRivalHash: "",
		reloadRivalHash: "",
		deleteRivalList: "",
		calcDJPoint: "",
		viewStatus: "",
		rivalDefault: "",
		slotCheck: "",
		selectReset: "",
		rivalViewCheck: "",
		copyData: "",
		readOldData: "",
		resetUserLoadData: "",
		sendUserLoadData: "",

		//musictab.js
		openMusicWindow: "",

		//export.js
		exportScore: "",

		//export_clear_manager.js
		exportClearManager: "",

		//export_fcphp.js
		exportFCPHP: "",

		//export_play_record.js
		id_playrecord: "",
		iidxpr_writeButton: "",
		iidxpr_writeScore: "",

		//export_scoreviewer.js
		crc32: "",
		crc32_fix: "",
		importScoreViewer: "",
		exportScoreViewer: "",
		importScoreViewerSlot: "",
		exportScoreViewerSlot: "",
		margeScoreViewerSlot: "",

		//export_snj-kzms.js
		importSnjKzms: "",
		
		//export_data_analyzer.js
		exportDataAnalyzer: "",
		
		//aprilfool.js
		aprilFool: "",
	}

with(ScoreViewerIIDX19){

//参考：https://developer.mozilla.org/ja/Code_snippets/Tabbed_browser
window.addEventListener("load",function () {
	gBrowser.addEventListener("load", function(event){
		if(event.originalTarget instanceof HTMLDocument) {
			var doc = event.originalTarget;
			var URL_tmp = doc.URL.replace("https://","http://");
			var tmp = URL_tmp.indexOf("?");
			if(tmp != -1){
				URL_tmp = URL_tmp.slice(0, tmp);
			}
			var tmp = URL_tmp.indexOf("index.html");
			if(tmp != -1){
				URL_tmp = URL_tmp.slice(0, tmp);
			}
			if(URL_tmp.match(URL1)){
				if(URL_tmp==URL_rival){
					editRival(doc);
				}
				if(doc.getElementsByTagName("head")[0].innerHTML.match('/gate/p/images/favicon.ico')){
//					var txt = "<input type=\"button\" id=\"openScoreViewer\" value=\"Score Viewer for beatmania IIDX 19 Lincleを起動\"><BR>";
//					doc.body.innerHTML = txt + doc.body.innerHTML;
//					doc.getElementById("openScoreViewer").addEventListener("click", (function(){
					var elements = doc.getElementsByTagName("body");
					var body = elements[0];
					var input = doc.createElement("input");
					input.type = "button";
					input.id = "openScoreViewer";
					input.value = "Score Viewer for beatmania IIDX 19 Lincleを起動";
					input.addEventListener("click", (function(){
						return function(){
							scoreViewerSetup();
						}
					})(), false);
					body.insertBefore(input, body.firstChild);
				}
			}else if(doc.URL.match(URL_official_login)){
				if(addon_Branch.getBoolPref("first_caution")){
					if(doc.getElementById("nob_m") == null){
						var body = doc.getElementsByTagName("body")[0];
						var input = doc.createElement("input");
						input.type = "hidden";
						input.id = "nob_m";
						input.value = "1";
						body.insertBefore(input, body.firstChild);

						var f = doc.getElementsByTagName("form")[0];
						f.addEventListener("submit", (function(){
							return function(){
								f.removeEventListener("submit", arguments.callee, false);
								var txt = '';
								txt += 'ログイン成功時の情報は以下の通りです。\n\n';
								for(var i=0;i<f.length;i++){
									if(f.elements[i].name != ''){
										txt += f.elements[i].name + ': ';
										var value = f.elements[i].value;
										if(f.elements[i].name == "pass"){
											var hide_max = 5;
											if(value.length > hide_max){
												var hide = value.length - hide_max;
											}else{
												var hide = 1;
											}
											value = value.substr(0, value.length - hide);
											for(var j=0; j<hide; j++){
												value += "*";
											}
										}
										txt += value + '\n';
									}
								}
								var txt2 = '';
								txt2 += 'Score Viewer/Follow Editorを含め、\nFirefoxアドオンでは前述のように入力したID/パスワードを抜き取り、\n外部に送信することが可能です。\n\n';
								txt2 += '危険性を十分に理解した上で、\n作者(nob_m)が一切の責任を負わないことに同意できる方のみ、\nScore Viewer/Follow Editorをご利用ください。\n\n';
								txt2 += '(キャンセルを押すと次回以降この表示はされなくなります。)';
								gBrowser.addEventListener("load", function(event){
									var e = event.originalTarget;
									if(e instanceof HTMLDocument) {
										if(e.URL.match('p.eagate.573.jp')){
											gBrowser.removeEventListener("load", arguments.callee, true);
											if((!(e.URL.match('p.eagate.573.jp/gate/p/login.html')))&&(e.body.innerHTML.match('http://eagate.573.jp/gate/p/logout.html'))){
												alert(txt);
												if(!(confirm(txt2))){
													addon_Branch.setBoolPref("first_caution", false);
												}
											}
										}
									}
								}, true);
							}
						})(),false);
					}
				}
//			}else if((doc.URL==URL2)||(doc.URL==URL3)){
//				exportScore(doc);
			}else if(doc.URL.match(URL_iidxpr)){
				iidxpr_writeButton(doc);
			}
		}
	}, true);
},false);

}

}
