if(!window.ScoreViewerIIDX19){
	ScoreViewerIIDX19_setup();
}
with(ScoreViewerIIDX19){

userDataDefault = function (){
	var obj = new Object();

	obj.name = "NODATA";
	obj.playcount = new Object();
	obj.clear = new Object();
	obj.djlv = new Object();
	obj.next = new Object();
	obj.score = new Object();
	obj.pgreat = new Object();
	obj.great = new Object();
	obj.miss = new Object();
	obj.disabled = true;
	obj.category = -1;
	obj.topname = new Object();
	obj.version = -1;
	
	obj.id = "NODATA";
	obj.time = new Object();
	obj.time.main = "";

	return obj;
}

sortMusic = function (){
	for(var i=0; i<music_id.length; i++){
		for(var j=music_id.length-1; j>i; j--){
			var str1 = strFullToHalf(music_list["music_list"][music_id[j-1]]["name"].toUpperCase());
			var str2 = strFullToHalf(music_list["music_list"][music_id[j]]["name"].toUpperCase());
			if(str1 > str2){
				var tmp = music_id[j-1];
				music_id[j-1] = music_id[j];
				music_id[j] = tmp;
			}
		}
	}
	return;
}

scoreViewerSetup = function (){
	var sv19_prefs = Components.classes["@mozilla.org/preferences-service;1"].getService(Components.interfaces.nsIPrefService);
	var sv19_Branch = sv19_prefs.getBranch("extensions.ScoreViewerForIIDX19.");

	style_name = new Array("SINGLE", "SINGLE", "SINGLE", "DOUBLE", "DOUBLE", "DOUBLE");
	style_name[-1] = "SINGLE";
	style_name2 = new Array("SP", "SP", "SP", "DP", "DP", "DP");
	style_name2[-1] = "SP";
	diff_name = new Array("NORMAL", "HYPER", "ANOTHER", "NORMAL", "HYPER", "ANOTHER");
	diff_name[-1] = "BEGINNER";
	diff_name2 = new Array("SPN", "SPH", "SPA", "DPN", "DPH", "DPA");
	diff_name2[-1] = "SPB";
	diff_color = new Array("#50FFFF", "#FFFF50", "#FF5050", "#50FFFF", "#FFFF50", "#FF5050");
	diff_color[-1] = "#50FF50";
	num_rival_view = 0;

//	music_list = new Object();//{version->i->{version, name}}, {music_list->mid->{version, mid, name, diff[0-5]}}
//	music_id = new Object();//music_id[通し番号] = mid
	music_id = new Array();
	for(var i in music_list['music_list']){
		music_id.push(music_list['music_list'][i]['mid']);
	}
	sortMusic();

//	view_data = new Object();
	user_data = new Array();
//	for(var i=0; i<=20; i++){
//		userDataDefault(i);
//	}

	view_list = new Array();

	rival_data = new Array();
	rival_top_data = new Array();
	unofficial_diff = new Object();
	unofficial_diff.time = "none";

	readTask = {
		wait: new Array(),
		comp: new Array(),
		fail: new Array()
	};

	timeout = sv19_Branch.getIntPref("timeout") * 1000;

	mainTab = gBrowser.getBrowserForTab(gBrowser.selectedTab = gBrowser.addTab("chrome://ScoreViewerForIIDX19/content/main.html"));
	mainTab.addEventListener("load", function(){
		mainTab.removeEventListener("load", arguments.callee, true);
		//ページ破棄時
		mainTab.addEventListener("beforeunload", function(){
			mainTab.removeEventListener("beforeunload", arguments.callee, true);
			//ソート情報保存
			if(sv19_Branch.getBoolPref("save_sort")){
				sv19_Branch.setIntPref("sort1_diff", mainTab.contentDocument.getElementById('sort1_diff').value);
				sv19_Branch.setIntPref("sort1_cat", mainTab.contentDocument.getElementById('sort1_cat').value);
				sv19_Branch.setIntPref("sort1_order", mainTab.contentDocument.getElementById('sort1_order').value);
				sv19_Branch.setIntPref("sort2_diff", mainTab.contentDocument.getElementById('sort2_diff').value);
				sv19_Branch.setIntPref("sort2_cat", mainTab.contentDocument.getElementById('sort2_cat').value);
				sv19_Branch.setIntPref("sort2_order", mainTab.contentDocument.getElementById('sort2_order').value);
			}
		}, true);
		//ソート情報読み込み
		if(sv19_Branch.getBoolPref("save_sort")){
			var tmp_array = new Array(
				"sort1_diff",
				"sort1_cat",
				"sort1_order",
				"sort2_diff",
				"sort2_cat",
				"sort2_order"
			);
			for(var i=0; i<tmp_array.length; i++){
				var tmp_select = mainTab.contentDocument.getElementById(tmp_array[i]);
				var tmp_int = sv19_Branch.getIntPref(tmp_array[i]);
				for(var j=0; j<tmp_select.length; j++){
					if(tmp_int == tmp_select.options[j].value){
						tmp_select.selectedIndex = j;
						tmp_select.value = tmp_int;
						break;
					}
				}
			}
		}
		mainTab.contentDocument.title += "  ver." + scoreviewer19_version;
		readVersionInfo();
		readInfo();
		setupWindow();
		writeCategory();
		categoryDisable();
		if(sv19_Branch.getBoolPref("autoload")){
			try{
				var tmp = getData();
				if(tmp == 0){
					mainTab.contentDocument.getElementById("time_unofficial_diff").innerHTML = unofficial_diff.time;
				}
			}catch(e){
				alert("データが読み込めません。\n" + e);
			}
		}
		buttonEnable();
		rivalDefault();
		rivalViewCheck();
	}, true);

	return;
}

readInfo = function (){
	var sv19_prefs = Components.classes["@mozilla.org/preferences-service;1"].getService(Components.interfaces.nsIPrefService);
	var sv19_Branch = sv19_prefs.getBranch("extensions.ScoreViewerForIIDX19.");

	if(sv19_Branch.getBoolPref("info_check")){
		var req = new XMLHttpRequest();
		req.open('GET', URL_info + '?random=' + Math.random(), true);
		req.onreadystatechange = function (aEvt) {
			if(req.readyState == 4) {
				if(req.status == 200){
					mainTab.contentDocument.getElementById("info").innerHTML = req.responseText;
				}
			}
		};
		req.send(null);
	}

	return;
}

readVersionInfo = function (){
	var sv19_prefs = Components.classes["@mozilla.org/preferences-service;1"].getService(Components.interfaces.nsIPrefService);
	var sv19_Branch = sv19_prefs.getBranch("extensions.ScoreViewerForIIDX19.");

	if(sv19_Branch.getBoolPref("vinfo_check")){
		var req1 = new XMLHttpRequest();
		req1.open('GET', URL_vdata + '?random=' + Math.random(), true); 
		req1.onreadystatechange = function (aEvt) {
			if(req1.readyState == 4) {
				if(req1.status == 200){
					if(scoreviewer19_version != req1.responseText){
						var req2 = new XMLHttpRequest();
						req2.open('GET', URL_vinfo + '?random=' + Math.random(), true); 
						req2.onreadystatechange = function (aEvt) {
							if(req2.readyState == 4) {
								if(req2.status == 200){
									mainTab.contentDocument.getElementById("vinfo").innerHTML = req2.responseText;
								}
							}
						};
						req2.send(null);
					}
				}
			}
		};
		req1.send(null);
	}

	return;
}

}
