if(!window.ScoreViewerIIDX19){
	ScoreViewerIIDX19_setup();
}
with(ScoreViewerIIDX19){

exportScore = function (doc){
	var req = new XMLHttpRequest();
	req.open('GET', doc.URL, true); 
	req.onreadystatechange = function (aEvt) {
		if(req.readyState == 4) {
			if(req.status == 200){
				var output = "test";
				doc.getElementById("writeButton").innerHTML += "<input type=\"button\" id=\"writeScore\" value=\"AC19のスコアを貼り付け\">";
				doc.getElementById("writeScore").addEventListener("click", (function(){
					return function(){
						if(confirm('Score Viewer for beatmania IIDX 19 Lincleからスコアをロードしますか？\n(読み込み完了までに時間がかかる場合があります。)')){
							for(var i=0; i<doc.forms.namedItem("form1").elements.namedItem("from").length; i++){
								if(doc.forms.namedItem("form1").elements.namedItem("from").options[i].value == "AC19"){
									doc.forms.namedItem("form1").elements.namedItem("from").selectedIndex = i;
								}
							}
							getData();
							output = "AC19,\n";
							var note = -1;
							for(var i in music_id){
								output += music_id[i] + ",";
								for(var j=0; j<6; j++){
									output += user_data[0].clear[music_id[i]][j] + ",";
									if(user_data[0].djlv[music_id[i]][j] == -1){
										note = -1;
									}else{
										if(user_data[0].djlv[music_id[i]][j]==7){
											note = (Number(user_data[0].score[music_id[i]][j]) + Number(user_data[0].next[music_id[i]][j])) / 2;
										}else{
											note = Math.floor((Number(user_data[0].score[music_id[i]][j]) + Number(user_data[0].next[music_id[i]][j])) * 9 / (user_data[0].djlv[music_id[i]][j]+2));
											note = Math.floor(note / 2);
										}
									}
									output += note + ",";
									if(user_data[0].score[music_id[i]][j] == "&nbsp;"){
										user_data[0].score[music_id[i]][j] = "";
									}
									output += user_data[0].score[music_id[i]][j] + ",";
									if(user_data[0].pgreat[music_id[i]][j] == "&nbsp;"){
										user_data[0].pgreat[music_id[i]][j] = "";
									}
									output += user_data[0].pgreat[music_id[i]][j] + ",";
									if(user_data[0].great[music_id[i]][j] == "&nbsp;"){
										user_data[0].great[music_id[i]][j] = "";
									}
									output += user_data[0].great[music_id[i]][j] + ",";
									if(user_data[0].miss[music_id[i]][j] == "&nbsp;"){
										user_data[0].miss[music_id[i]][j] = "";
									}
									output += user_data[0].miss[music_id[i]][j] + ",";
								}
								output += "\n";
							}
							doc.forms.namedItem("form1").elements.namedItem("text1").value = output;
						}
					}
				})(), false);
			}
		}
	};
	req.send(null);

	return;
}

}
