if(!window.ScoreViewerIIDX19){
	ScoreViewerIIDX19_setup();
}
with(ScoreViewerIIDX19){

exportDataAnalyzer = function (){
	buttonDisableImport("DataAnalyzer", true);
	
	var udata = user_data[mainTab.contentDocument.getElementById("dataanalyzer_rival").value];
	var obj = new Array();
	var txt = '';

	if(udata.category != 2){
		try{
			txt += 'userdata<>' + udata.name + '<>' + udata.id.substr(0,4) + udata.id.substr(5,4) + '\r\n';

			var txt_play = '';
			var txt_clear = '';
			var txt_djlv = '';
			var txt_score = '';
			var txt_pgreat = '';
			var txt_great = '';
			var txt_miss = '';
			for(var i in music_list.music_list){
				if(i in udata.clear){
					if(i in udata.playcount){
						txt_play += 'playcount<>' + i;
						for(var j=0; j<2; j++){
		  					txt_play += '<>' + udata.playcount[i][j];
						}
						txt_play += '\r\n';
					}

					if(i in udata.clear){
						txt_clear += 'clear<>' + i;
						for(var j=0; j<6; j++){
		 					txt_clear += '<>' + udata.clear[i][j];
						}
						txt_clear += '\r\n';
					}

					if(i in udata.djlv){
						txt_djlv += 'djlv<>' + i;
						for(var j=0; j<6; j++){
		 					txt_djlv += '<>' + udata.djlv[i][j];
						}
						txt_djlv += '\r\n';
					}

					if(i in udata.score){
						txt_score += 'score<>' + i;
						for(var j=0; j<6; j++){
		 					txt_score += '<>' + udata.score[i][j];
						}
						txt_score += '\r\n';
					}

					if(i in udata.pgreat){
						txt_pgreat += 'pgreat<>' + i;
						txt_great += 'great<>' + i;
						for(var j=0; j<6; j++){
		 					txt_pgreat += '<>' + udata.pgreat[i][j];
		 					txt_great += '<>' + udata.great[i][j];
						}
						txt_pgreat += '\r\n';
						txt_great += '\r\n';
					}

					if(i in udata.miss){
						txt_miss += 'miss<>' + i;
						for(var j=0; j<6; j++){
		 					txt_miss += '<>' + udata.miss[i][j];
						}
						txt_miss += '\r\n';
					}
				}
			}
			txt += txt_play;
			txt += txt_clear;
			txt += txt_djlv;
			txt += txt_score;
			txt += txt_pgreat;
			txt += txt_great;
			txt += txt_miss;
		}catch(e){
			buttonDisableImport("DataAnalyzer", false);
			alert("エラーが発生しました。\n" + e);
			return;
		}

		//参考 https://developer.mozilla.org/ja/XUL_Tutorial/Open_and_Save_Dialogs
		//参考 http://efcl.info/2009/0813/res1249/
		//参考 http://piro.sakura.ne.jp/xul/tips/x0022.html
		var filename = "data-analyzer.txt";
		var content = txt;
		// オブジェクト生成
		var nsIFilePicker = Components.interfaces.nsIFilePicker;
		var fp = Components.classes["@mozilla.org/filepicker;1"].createInstance(nsIFilePicker);
		fp.init(window, "DATA ANALYZER用に書き出すファイル名を指定", Components.interfaces.nsIFilePicker.modeSave);
		fp.defaultString = filename;
		var result = fp.show();
		if((result == nsIFilePicker.returnOK)||(result == nsIFilePicker.returnReplace)){
			var thefile = fp.file;
			// 文字コード指定
			var charset = 'UTF-8';
			// 書込む文字列
			var string = content;
			// ファイルストリーム生成
			var fileStream = Components.classes['@mozilla.org/network/file-output-stream;1']
			.createInstance(Components.interfaces.nsIFileOutputStream);
			// 書込み専用で初期化
			fileStream.init(thefile, 0x2a, 0x200, false);
			// 文字列書込みストリーム生成
			var converterStream = Components.classes['@mozilla.org/intl/converter-output-stream;1']
			.createInstance(Components.interfaces.nsIConverterOutputStream);
			// 文字列書込みストリーム初期化
			converterStream.init(fileStream, charset, string.length,
			Components.interfaces.nsIConverterInputStream.DEFAULT_REPLACEMENT_CHARACTER);
			// 文字列書込み
			converterStream.writeString(string);
			// 文字列書込みストリームクローズ
			converterStream.close();
			// ファイルストリームクローズ
			fileStream.close();
			alert("IIDX DATA ANALYZER用のファイル出力が完了しました。");
		}
	}else{
		alert("TOP・平均データは出力できません。");
	}
	buttonDisableImport("DataAnalyzer", false);

	return;
}

}
